/*
    File name: init.sqf, at 12.07.2022 (вт)
	author: Sygsky
	description: none
	returns: nothing
*/
// Common section for the server and the client code

X_INIT = false;
X_Server = false; X_Client = false; X_JIP = false; X_SPE = false;
// X_InstalledECS = isClass (configFile >> "cfgVehicles" >> "ECS_basic"); // check some addons to be installed

X_MP = (playersNumber east + playersNumber west + playersNumber resistance + playersNumber civilian) > 0;

if (isServer) then {
	X_Server = true;
	if (!(isNull player)) then {X_Client = true;X_SPE = true;};
	X_INIT = true;
} else {
	X_Client = true;
	if (isNull player) then {
		X_JIP = true;
		[] spawn {waitUntil {!(isNull player)};X_INIT = true;};
	} else {
		X_INIT = true;
	};
};

hint localize format["+++ init.sqf: isServer = %1, X_Server = %2, X_Client = %3, X_JIP = %4, X_SPE = %5, X_MP = %6, X_INIT = %7, mission ""%8"" in world ""%9""",
	isServer, X_Server, X_Client, X_JIP, X_SPE, X_MP, X_INIT, missionName, worldName];

// Section for something really usefull
// ...
call compile preprocessFileLineNumbers "utils.sqf";

// Server code section
if (X_Server) then {
	hint localize "+++ Server side code executed";
	// Section for all global variables declaration
	mission1Player = ""; // player who started mission #1
	publicVariable "mission1Player";
	mission2Player = ""; // player who started mission #2
	publicVariable "mission2Player";
	// etc...

	// ...
	[] spawn {
		private ["_old_name"];
		_old_name = "<>";
		while { true } do {
			if ( _old_name != mission1Player ) then {
				hint localize format["+++ server init: time %1, mission1Player => ""%2""", time,  mission1Player];
				_old_name = mission1Player;
			};
			sleep 1;
		};
	};

	// handle each player connection
	// special case for ACE mod:
	if (!isNil "ace_sys_network_OPCB") then {
		ace_sys_network_OPCB set [count ace_sys_network_OPCB , {[_this select 0] execVM "serverOPC.sqf"} ];
	} else { // if no ACE mod added
		onPlayerConnected "xhandle = [_name] execVM ""x_serverOPC.sqf""";
	};
	hint localize format["ACE:ace_sys_network_OPCB = %1", ace_sys_network_OPCB];

};

// Client code section
if (X_Client) then {

	hint localize "+++ Client side code executed";
	// initiate only if not set values from server
	if (isNil "mission1Player") then { mission1Player = ""};
	if (isNil "mission2Player") then { mission2Player = ""};
	// ...
	(format["+++ init.sqf: client mission1Player = ""%1""", mission1Player]) call print;

	FLAG_BASE addAction ["Test mission #1", "test.sqf"];
	FLAG_BASE addAction ["Run mission #1", "mission1.sqf"];
	FLAG_BASE addAction ["Run mission #2", "mission2.sqf"];

	execVM "intro.sqf";

	"+++ Welcome to the last island of the freedom +++" call print;
	sleep 5;
	"+++ Demo: how to keep info on server and sent it to any new client with means of ""publicVariable"" +++" call print;

};
